// ignore_for_file: lines_longer_than_80_chars
import 'package:bip39/bip39.dart' as bip39;
import 'package:chia_crypto_utils/chia_crypto_utils.dart';
import 'package:test/expect.dart';
import 'package:test/scaffolding.dart';

Future<void> main() async {
  const fullNodeUrl = 'https://chia.irulast-prod.com';

  const fullNodeRpc = FullNodeHttpRpc(
    fullNodeUrl,
  );

  ChiaNetworkContextWrapper().registerNetworkContext(Network.mainnet);

  // KEYWORDS
  const usage = <String>['usage'];
  const hints = <String>['hint'];
  const snowy = <String>['snow'];
  const birds = <String>['bird'];

  const remix = <String>['remind'];
  const china = <String>['machine'];
  const zebra = <String>['zebra'];
  const nicer = <String>['nice'];

  const jumbo = <String>['jump'];
  const index = <String>['index'];
  const medal = <String>['medal'];
  const leafy = <String>['leaf'];

  const kings = <String>['kingdom'];
  const fixes = <String>['fix'];

  // const quirk = <String>['equip', 'inquiry'];
  // const acorn = <String>['acoustic', 'bacon'];
  // const dingo = <String>['pudding', 'wedding'];
  // const oxide = <String>['box', 'fox', 'oxygen'];
  // const prove = <String>['approve', 'improve', 'provide'];
  // const edify = <String>['credit', 'edit', 'media', 'predict'];
  // const yacht = <String>['loyal', 'royal', 'voyage', 'yard'];
  // const topaz = <String>['laptop', 'top', 'topic', 'topple'];
  // const graze = <String>['diagram', 'grab', 'grace', 'grain', 'grant', 'grape', 'grass', 'gravity'];
  // const wacky = <String>['always', 'awake', 'aware', 'away', 'awkward', 'dwarf', 'forward', 'reward', 'runway', 'subway', 'swallow', 'swamp', 'swap', 'swarm', 'toward', 'unaware', 'wage', 'wagon', 'wait', 'walk', 'wall', 'walnut', 'want', 'warfare', 'warm', 'warrior', 'wash', 'wasp', 'waste', 'water', 'wave', 'way'];
  // const viper = <String>['advice, civil', 'convince', 'device', 'divide', 'evidence', 'evil', 'gravity', 'invite', 'movie', 'obvious', 'provide', 'review', 'service', 'viable', 'vibrant', 'vicious', 'victory', 'video', 'view', 'village', 'vintage', 'violin', 'virtual', 'virus', 'visa', 'visit', 'visual', 'vital', 'vivid '];
  // const xrays = <String>['anxiety', 'axis', 'box', 'exact', 'example', 'excess', 'exchange', 'excite', 'exclude', 'excuse', 'execute', 'exercise', 'exhaust', 'exhibit', 'exile', 'exist', 'exit', 'exotic', 'expand', 'expect', 'expire', 'explain', 'expose', 'express', 'extend', 'extra', 'fix', 'fox', 'galaxy', 'index', 'luxury', 'matrix', 'maximum', 'mix', 'mixed', 'mixture', 'next', 'oxygen', 'relax', 'six', 'taxi', 'text'];

  // TIMELORDS
  const skull = <String>['skull'];
  const flame = <String>['flame'];
  const crown = <String>['crowd'];
  const circle = <String>['circle'];

  const leaf = <String>['leaf'];
  const eye = <String>['eye'];
  const rainbow = <String>['rain'];
  const heart = <String>['heart'];

  const smile = <String>['smile'];
  const diamond = <String>['diamond'];
  const hourglass = <String>['hourglass'];
  const star = <String>['start'];

  const triangle = <String>['trial'];
  const key = <String>['key'];
  const square = <String>['square'];

  const candidates = 'usage index zebra nice '
                     'medal skull flame crowd '
                     'light squirrel circle butter '

                     'leaf kingdom fix hint '
                     'snow bird remind eye '
                     'rain heart smile master '
                     
                     'pizza diamond hour start';

  List<String> findAllPermutations(String source) {
    final allPermutations = <List<String>>[];

    void permutate(List<String> list, int cursor) {
      // when the cursor gets this far, we've found one permutation, so save it
      if (cursor == list.length) {
        allPermutations.add(list);
        return;
      }

      for (var i = cursor; i < list.length; i++) {
        final permutation = List<String>.from(list);
        permutation[cursor] = list[i];
        permutation[i] = list[cursor];
        permutate(permutation, cursor + 1);
      }
    }

    permutate(source.split(''), 0);

    final strPermutations = <String>[];
    for (final permutation in allPermutations) {
      strPermutations.add(permutation.join());
    }

    return strPermutations;
  }

  test('Find special mnemonic', () async {
    var allPermutations = findAllPermutations(candidates);

    for(var i = 0;)
  });
}

  // String recursive_append(int index, int position, String phrase, List<String> words) {
  //   for (var i = 0; i  < words.length; i++) {
  //       if (i == position) {
  //         return phrase;
  //       }

  //       var mnemonic_b = '$mnemonic_a ${words[b]} ';
  // }
  // test('Find special mnemonic', () async {
  //   // const candidates = [quirk, acorn, dingo, oxide, prove, edify, yacht, topaz, graze, wacky, viper, xrays];

  //   final words = candidates.split(' ');
  //   var considered_words = <String>[];

  //   for (var a = 0; a  < words.length; a++) {
  //     var mnemonic_a = words[a];
  //     considered_words.add(words[a]);

  //     for (var b = 0; b  < words.length; b++) {
  //       if (considered_words.contains(words[b])) {
  //         continue;
  //       }

  //       var mnemonic_b = '$mnemonic_a ${words[b]}';
  //       considered_words.add(words[b]);

  //       for (var c = 0; c  < words.length; c++) {
  //         if (considered_words.contains(words[c])) {
  //           continue;
  //         }

  //         var mnemonic_c = '$mnemonic_b ${words[c]}';
  //         considered_words.add(words[c]);

  //         for (var d = 0; d  < words.length; d++) {
  //           if (considered_words.contains(words[d])) {
  //             continue;
  //           }

  //           var mnemonic_d = '$mnemonic_c ${words[d]}';
  //           considered_words.add(words[d]);

  //           for (var e = 0; e  < words.length; e++) {
  //             if (considered_words.contains(words[e])) {
  //               continue;
  //             }

  //             var mnemonic_e = '$mnemonic_d ${words[e]}';
  //             considered_words.add(words[e]);

  //             for (var f = 0; f  < words.length; f++) {
  //               if (considered_words.contains(words[f])) {
  //                 continue;
  //               }

  //               var mnemonic_f = '$mnemonic_e ${words[f]}';
  //               considered_words.add(words[f]);

  //               for (var g = 0; g  < words.length; g++) {
  //                 if (considered_words.contains(words[g])) {
  //                   continue;
  //                 }

  //                 var mnemonic_g = '$mnemonic_f ${words[g]}';
  //                 considered_words.add(words[g]);

  //                 for (var h = 0; h  < words.length; h++) {
  //                   if (considered_words.contains(words[h])) {
  //                     continue;
  //                   }

  //                   var mnemonic_h = '$mnemonic_g ${words[h]}';
  //                   considered_words.add(words[h]);

  //                   for (var i = 0; i  < words.length; i++) {
  //                     if (considered_words.contains(words[i])) {
  //                       continue;
  //                     }

  //                     var mnemonic_i = '$mnemonic_h ${words[i]}';
  //                     considered_words.add(words[i]);

  //                     for (var j = 0; j  < words.length; j++) {
  //                       if (considered_words.contains(words[j])) {
  //                         continue;
  //                       }

  //                       var mnemonic_j = '$mnemonic_i ${words[j]}';
  //                       considered_words.add(words[j]);

  //                       for (var k = 0; k  < words.length; k++) {
  //                         if (considered_words.contains(words[k])) {
  //                           continue;
  //                         }

  //                         var mnemonic_k = '$mnemonic_j ${words[k]}';
  //                         considered_words.add(words[k]);

  //                         for (var l = 0; l  < words.length; l++) {
  //                           if (considered_words.contains(words[l])) {
  //                             continue;
  //                           }

  //                           var mnemonic_l = '$mnemonic_k ${words[l]}';
  //                           considered_words.add(words[l]);

  //                           for (var m = 0; m  < words.length; m++) {
  //                             if (considered_words.contains(words[m])) {
  //                               continue;
  //                             }

  //                             var mnemonic_m = '$mnemonic_l ${words[m]}';
  //                             considered_words.add(words[m]);

  //                             for (var n = 0; n  < words.length; n++) {
  //                               if (considered_words.contains(words[n])) {
  //                                 continue;
  //                               }

  //                               var mnemonic_n = '$mnemonic_m ${words[n]}';
  //                               considered_words.add(words[n]);

  //                               for (var o = 0; o  < words.length; o++) {
  //                                 if (considered_words.contains(words[o])) {
  //                                   continue;
  //                                 }

  //                                 var mnemonic_o = '$mnemonic_n ${words[o]}';
  //                                 considered_words.add(words[o]);

  //                                 for (var p = 0; p  < words.length; p++) {
  //                                   if (considered_words.contains(words[p])) {
  //                                     continue;
  //                                   }

  //                                   var mnemonic_p = '$mnemonic_o ${words[p]}';
  //                                   considered_words.add(words[p]);

  //                                   for (var q = 0; q  < words.length; q++) {
  //                                     if (considered_words.contains(words[q])) {
  //                                       continue;
  //                                     }

  //                                     var mnemonic_q = '$mnemonic_p ${words[q]}';
  //                                     considered_words.add(words[q]);

  //                                     for (var r = 0; r  < words.length; r++) {
  //                                       if (considered_words.contains(words[r])) {
  //                                         continue;
  //                                       }

  //                                       var mnemonic_r = '$mnemonic_q ${words[r]}';
  //                                       considered_words.add(words[r]);

  //                                       for (var s = 0; s  < words.length; s++) {
  //                                         if (considered_words.contains(words[s])) {
  //                                           continue;
  //                                         }

  //                                         var mnemonic_s = '$mnemonic_r ${words[s]}';
  //                                         considered_words.add(words[s]);

  //                                         for (var t = 0; t  < words.length; t++) {
  //                                           if (considered_words.contains(words[t])) {
  //                                             continue;
  //                                           }

  //                                           var mnemonic_t = '$mnemonic_s ${words[t]}';
  //                                           considered_words.add(words[t]);

  //                                           for (var u = 0; u  < words.length; u++) {
  //                                             if (considered_words.contains(words[u])) {
  //                                               continue;
  //                                             }

  //                                             var mnemonic_u = '$mnemonic_t ${words[u]}';
  //                                             considered_words.add(words[u]);

  //                                             for (var v = 0; v  < words.length; v++) {
  //                                               if (considered_words.contains(words[v])) {
  //                                                 continue;
  //                                               }

  //                                               var mnemonic_v = '$mnemonic_u ${words[v]}';
  //                                               considered_words.add(words[v]);

  //                                               for (var w = 0; w  < words.length; w++) {
  //                                                 if (considered_words.contains(words[w])) {
  //                                                   continue;
  //                                                 }

  //                                                 var mnemonic_w = '$mnemonic_v ${words[w]}';
  //                                                 considered_words.add(words[w]);

  //                                                 for (var x = 0; x  < words.length; x++) {
  //                                                   if (considered_words.contains(words[x])) {
  //                                                     continue;
  //                                                   }

  //                                                   final mnemonic_x = '$mnemonic_w ${words[x]}';
  //                                                   considered_words.add(words[x]);

  //                                                   if (bip39.validateMnemonic(mnemonic_x)) {
  //                                                     print(mnemonic_x);
  //                                                   } else {
  //                                                     print('...');
  //                                                   }
  //                                                 }
  //                                               }
  //                                             }
  //                                           }
  //                                         }
  //                                       }
  //                                     }
  //                                   }
  //                                 }
  //                               }
  //                             }
  //                           }
  //                         }
  //                       }
  //                     }
  //                   }
  //                 }
  //               }
  //             }
  //           }
  //         }
  //       }
  //     }
  //   }

  //   // final keychainSecret = KeychainCoreSecret.fromMnemonic(mnemonicWords);
  //   // final masterPrivateKey = keychainSecret.masterPrivateKey;

  //   // final walletsSetList = <WalletSet>[];
  //   // for (var i = 0; i < 2; i++) {
  //   //   final set1 = WalletSet.fromPrivateKey(keychainSecret.masterPrivateKey, i);
  //   //   walletsSetList.add(set1);
  //   // }

  //   // final keychain = WalletKeychain.fromWalletSets(walletsSetList);

  //   // ChiaNetworkContextWrapper().registerNetworkContext(Network.mainnet);
  //   // final walletService = StandardWalletService();

  //   // final walletSet = <WalletSet>[];
  //   // for (var i = 0; i < 20; i++) {
  //   //   final set = WalletSet.fromPrivateKey(keychainSecret.masterPrivateKey, i);
  //   //   walletSet.add(set);

  //   //   final address = Address.fromPuzzlehash(set.hardened.puzzlehash, 'xch').address;
  //   //   print(' $address');
  //   // }
  // });
